<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: I2S.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">I2S.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * I2S.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Jul 23, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_I2S_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_I2S_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;driver/gpio.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;FreeRTOS.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="structdma__config__t.html">   12</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="structdma__config__t.html#acc8e1e52e09040835716e630b1680d0b">   13</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#acc8e1e52e09040835716e630b1680d0b">pin_reset</a>;          </div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a52c04d1b9363dcf03510cf494c1f9490">   14</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a52c04d1b9363dcf03510cf494c1f9490">pin_xclk</a>;           </div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="structdma__config__t.html#ad51c4f0e2dc10e5e743af5084924501d">   15</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#ad51c4f0e2dc10e5e743af5084924501d">pin_sscb_sda</a>;       </div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a433be12077ef21ef5591f767ea2c4d82">   16</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a433be12077ef21ef5591f767ea2c4d82">pin_sscb_scl</a>;       </div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a23f0ed2ce04b7048624df13729340da0">   17</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a23f0ed2ce04b7048624df13729340da0">pin_d7</a>;             </div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="structdma__config__t.html#accbcd22f5f6965a5729b9ad0e7f1b81f">   18</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#accbcd22f5f6965a5729b9ad0e7f1b81f">pin_d6</a>;             </div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="structdma__config__t.html#ad363a0b1873740aba2b550819da7afd1">   19</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#ad363a0b1873740aba2b550819da7afd1">pin_d5</a>;             </div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a5b8fad07874f0c3fe583671777261069">   20</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a5b8fad07874f0c3fe583671777261069">pin_d4</a>;             </div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a73f9b251874f208c3048d05cb3f2459d">   21</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a73f9b251874f208c3048d05cb3f2459d">pin_d3</a>;             </div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a6fc0f3d947cc5f78cdbd98074a7c9af9">   22</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a6fc0f3d947cc5f78cdbd98074a7c9af9">pin_d2</a>;             </div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a9a87cec5fc0bd56e50136a1d334fc833">   23</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a9a87cec5fc0bd56e50136a1d334fc833">pin_d1</a>;             </div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a231d4199be7cbd7653b525680ac51cf5">   24</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a231d4199be7cbd7653b525680ac51cf5">pin_d0</a>;             </div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a8749b7acc84c18ea799613f490f1041d">   25</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a8749b7acc84c18ea799613f490f1041d">pin_vsync</a>;          </div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a840d4f12fe2e5fd8d4a1fec9e1fde84f">   26</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#a840d4f12fe2e5fd8d4a1fec9e1fde84f">pin_href</a>;           </div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structdma__config__t.html#aa10372c169b65af008b2e7dff4a17d79">   27</a></span>&#160;    gpio_num_t <a class="code" href="structdma__config__t.html#aa10372c169b65af008b2e7dff4a17d79">pin_pclk</a>;           </div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="structdma__config__t.html#a12553e7d65c0d62fa229d5c4bd7a157d">   29</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structdma__config__t.html#a12553e7d65c0d62fa229d5c4bd7a157d">xclk_freq_hz</a>;       </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;} <a class="code" href="structdma__config__t.html">dma_config_t</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="classDMAData.html">   32</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDMAData.html">DMAData</a> {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    uint32_t getLength() {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordflow">return</span> m_length;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    }</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    uint8_t* getData() {</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordflow">return</span> m_pData;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    }</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> free() {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">delete</span>[] m_pData;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        m_pData = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classI2S.html">I2S</a>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    uint32_t m_length;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    uint8_t* m_pData;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;};</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classI2S.html">   51</a></span>&#160;<span class="keyword">class </span><a class="code" href="classI2S.html">I2S</a> {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="classI2S.html">I2S</a>();</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classI2S.html">I2S</a>();</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2S.html#a2f50ba781190dad5e8fba252f737ae47">cameraMode</a>(<a class="code" href="structdma__config__t.html">dma_config_t</a> config, <span class="keywordtype">int</span> desc_count, <span class="keywordtype">int</span> sample_count);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="classDMAData.html">DMAData</a> waitForData();</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_dmaSemaphore;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;};</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_I2S_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="structdma__config__t_html_a9a87cec5fc0bd56e50136a1d334fc833"><div class="ttname"><a href="structdma__config__t.html#a9a87cec5fc0bd56e50136a1d334fc833">dma_config_t::pin_d1</a></div><div class="ttdeci">gpio_num_t pin_d1</div><div class="ttdef"><b>Definition:</b> I2S.h:23</div></div>
<div class="ttc" id="structdma__config__t_html_ad363a0b1873740aba2b550819da7afd1"><div class="ttname"><a href="structdma__config__t.html#ad363a0b1873740aba2b550819da7afd1">dma_config_t::pin_d5</a></div><div class="ttdeci">gpio_num_t pin_d5</div><div class="ttdef"><b>Definition:</b> I2S.h:19</div></div>
<div class="ttc" id="classDMAData_html"><div class="ttname"><a href="classDMAData.html">DMAData</a></div><div class="ttdef"><b>Definition:</b> I2S.h:32</div></div>
<div class="ttc" id="structdma__config__t_html_a8749b7acc84c18ea799613f490f1041d"><div class="ttname"><a href="structdma__config__t.html#a8749b7acc84c18ea799613f490f1041d">dma_config_t::pin_vsync</a></div><div class="ttdeci">gpio_num_t pin_vsync</div><div class="ttdef"><b>Definition:</b> I2S.h:25</div></div>
<div class="ttc" id="structdma__config__t_html_a6fc0f3d947cc5f78cdbd98074a7c9af9"><div class="ttname"><a href="structdma__config__t.html#a6fc0f3d947cc5f78cdbd98074a7c9af9">dma_config_t::pin_d2</a></div><div class="ttdeci">gpio_num_t pin_d2</div><div class="ttdef"><b>Definition:</b> I2S.h:22</div></div>
<div class="ttc" id="structdma__config__t_html_a52c04d1b9363dcf03510cf494c1f9490"><div class="ttname"><a href="structdma__config__t.html#a52c04d1b9363dcf03510cf494c1f9490">dma_config_t::pin_xclk</a></div><div class="ttdeci">gpio_num_t pin_xclk</div><div class="ttdef"><b>Definition:</b> I2S.h:14</div></div>
<div class="ttc" id="classI2S_html"><div class="ttname"><a href="classI2S.html">I2S</a></div><div class="ttdef"><b>Definition:</b> I2S.h:51</div></div>
<div class="ttc" id="structdma__config__t_html_a433be12077ef21ef5591f767ea2c4d82"><div class="ttname"><a href="structdma__config__t.html#a433be12077ef21ef5591f767ea2c4d82">dma_config_t::pin_sscb_scl</a></div><div class="ttdeci">gpio_num_t pin_sscb_scl</div><div class="ttdef"><b>Definition:</b> I2S.h:16</div></div>
<div class="ttc" id="structdma__config__t_html"><div class="ttname"><a href="structdma__config__t.html">dma_config_t</a></div><div class="ttdef"><b>Definition:</b> I2S.h:12</div></div>
<div class="ttc" id="classI2S_html_a2f50ba781190dad5e8fba252f737ae47"><div class="ttname"><a href="classI2S.html#a2f50ba781190dad5e8fba252f737ae47">I2S::cameraMode</a></div><div class="ttdeci">void cameraMode(dma_config_t config, int desc_count, int sample_count)</div><div class="ttdoc">EXPERIMENTAL.</div><div class="ttdef"><b>Definition:</b> I2S.cpp:231</div></div>
<div class="ttc" id="structdma__config__t_html_a23f0ed2ce04b7048624df13729340da0"><div class="ttname"><a href="structdma__config__t.html#a23f0ed2ce04b7048624df13729340da0">dma_config_t::pin_d7</a></div><div class="ttdeci">gpio_num_t pin_d7</div><div class="ttdef"><b>Definition:</b> I2S.h:17</div></div>
<div class="ttc" id="structdma__config__t_html_aa10372c169b65af008b2e7dff4a17d79"><div class="ttname"><a href="structdma__config__t.html#aa10372c169b65af008b2e7dff4a17d79">dma_config_t::pin_pclk</a></div><div class="ttdeci">gpio_num_t pin_pclk</div><div class="ttdef"><b>Definition:</b> I2S.h:27</div></div>
<div class="ttc" id="structdma__config__t_html_ad51c4f0e2dc10e5e743af5084924501d"><div class="ttname"><a href="structdma__config__t.html#ad51c4f0e2dc10e5e743af5084924501d">dma_config_t::pin_sscb_sda</a></div><div class="ttdeci">gpio_num_t pin_sscb_sda</div><div class="ttdef"><b>Definition:</b> I2S.h:15</div></div>
<div class="ttc" id="structdma__config__t_html_a840d4f12fe2e5fd8d4a1fec9e1fde84f"><div class="ttname"><a href="structdma__config__t.html#a840d4f12fe2e5fd8d4a1fec9e1fde84f">dma_config_t::pin_href</a></div><div class="ttdeci">gpio_num_t pin_href</div><div class="ttdef"><b>Definition:</b> I2S.h:26</div></div>
<div class="ttc" id="structdma__config__t_html_acc8e1e52e09040835716e630b1680d0b"><div class="ttname"><a href="structdma__config__t.html#acc8e1e52e09040835716e630b1680d0b">dma_config_t::pin_reset</a></div><div class="ttdeci">gpio_num_t pin_reset</div><div class="ttdef"><b>Definition:</b> I2S.h:13</div></div>
<div class="ttc" id="structdma__config__t_html_a5b8fad07874f0c3fe583671777261069"><div class="ttname"><a href="structdma__config__t.html#a5b8fad07874f0c3fe583671777261069">dma_config_t::pin_d4</a></div><div class="ttdeci">gpio_num_t pin_d4</div><div class="ttdef"><b>Definition:</b> I2S.h:20</div></div>
<div class="ttc" id="structdma__config__t_html_a73f9b251874f208c3048d05cb3f2459d"><div class="ttname"><a href="structdma__config__t.html#a73f9b251874f208c3048d05cb3f2459d">dma_config_t::pin_d3</a></div><div class="ttdeci">gpio_num_t pin_d3</div><div class="ttdef"><b>Definition:</b> I2S.h:21</div></div>
<div class="ttc" id="structdma__config__t_html_a231d4199be7cbd7653b525680ac51cf5"><div class="ttname"><a href="structdma__config__t.html#a231d4199be7cbd7653b525680ac51cf5">dma_config_t::pin_d0</a></div><div class="ttdeci">gpio_num_t pin_d0</div><div class="ttdef"><b>Definition:</b> I2S.h:24</div></div>
<div class="ttc" id="structdma__config__t_html_accbcd22f5f6965a5729b9ad0e7f1b81f"><div class="ttname"><a href="structdma__config__t.html#accbcd22f5f6965a5729b9ad0e7f1b81f">dma_config_t::pin_d6</a></div><div class="ttdeci">gpio_num_t pin_d6</div><div class="ttdef"><b>Definition:</b> I2S.h:18</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
<div class="ttc" id="structdma__config__t_html_a12553e7d65c0d62fa229d5c4bd7a157d"><div class="ttname"><a href="structdma__config__t.html#a12553e7d65c0d62fa229d5c4bd7a157d">dma_config_t::xclk_freq_hz</a></div><div class="ttdeci">int xclk_freq_hz</div><div class="ttdef"><b>Definition:</b> I2S.h:29</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
